// Copyright Fuzamei Corp. 2018 All Rights Reserved.
// Use of this source code is governed by a BSD-style
// license that can be found in the LICENSE file.

package executor

/*
区块链游戏：竞猜

一、玩法简介：
菠菜平台的管理员可以发布竞猜游戏，玩家可以对竞猜游戏进行投注.
截止时间达到后，玩家不能再进行投注，等待管理员公布结果.
竞猜内容的结果出来以后，管理员根据竞猜内容的真实结果触发智能合约进行输赢判断及结算。

二、创建及参与游戏
1、游戏管理员创建一局竞猜游戏时，可以设定竞猜内容，选项，赌注类型、大小及上限，截止时间等，比如竞猜一场足球比赛的结果，每注10BTY，单次最多可下100注，比赛开始前2小时截止投注。
2、玩家按规则进行投注，如果已过截止时间，则不能继续投注。

三、制胜策略
1、竞猜游戏对应的现实世界的结果出来以后，游戏管理员向区块链合约公布胜出的竞猜选项。
2、合约将投注的所有赌注向压注正确选项的玩家进行分配，分配原则根据每个地址实际投注的数额占比进行分配，比如一个地址投注占了正确选项投注总额的1/2，则该地址将获得所有赌注总额的1/2。
3、如果因为现实世界的突发异常导致竞猜不能继续（比如某场足球比赛因为不可抗力取消了），则管理员可以终止竞猜，合约将把所有地址的投注返还。

四、游戏过程和状态
1、创建游戏，一个地址可以作为本局竞猜游戏的管理员发起竞猜游戏。
2、管理员创建游戏时指定
   竞猜的内容（比如：未来的一场足球比赛）、
   选项（比如：A队赢或者B队赢或者打平）、
   赌注类型（比如BTY）、
   单注大小（比如5BTY）、
   单次最多可下注数量（比如100注）、
   截止下注时间（比如UTC时间2018-12-12 10:00:00或者区块高度1000000）
   游戏超时时间（比如UTC时间2018-12-20 10:00:00或者区块高度1080000）
   可下注的最大地址数量（比如20000个）
3、截止下注时间之前，玩家可根据游戏要求进行下注，下注金额注入合约地址。如果投注地址数量已经超过上限，则不允许新的地址投注。
4、截止下注时间达到后，玩家不可再下注。
5、现实世界的竞猜结果出现后，管理员在游戏超时时间之前公布游戏结果。
6、合约根据管理员输入的正确结果，对每个地址的投注进行输赢判断，并将所有赌注对所有竞猜正确的地址按各自的投注额占比进行比例分配。
7、如果因为现实世界的突发异常导致竞猜不能继续（比如某场足球比赛因为不可抗力取消了），则管理员可以终止竞猜，合约将把所有地址的投注返还。
8、如果游戏超时，管理员仍未公布结果，则任何地址都可以触发合约异常终止竞猜，合约中的投注返还给投注地址。
8、游戏状态：
   start(管理员)->bet(玩家)->publish(管理员)
   start(管理员)->bet(玩家)->abort(管理员)
   start(管理员)->bet(玩家)->timeout->abort(任何人)
   说明：这里的管理员不是特殊地址，而是谁创建竞猜游戏，谁就是本局竞猜游戏的管理员。
*/
